<ui:composition
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:h="http://xmlns.jcp.org/jsf/html"
        xmlns:f="http://xmlns.jcp.org/jsf/core"
        xmlns:p="http://primefaces.org/ui"
        template="/layout/template.xhtml">


    <ui:define name="content">

        <div class="card">
            <h:form>
                <p:growl id="msgs" showDetail="true" skipDetailIfEqualsSummary="true"/>
                <div class="grid">
                    <div class="col">

                        <p:panel header="Select a Configuration" style="margin-bottom:10px;">
                            <h:panelGrid columns="2" cellpadding="5">
                                <p:outputLabel for="configuration" value="Configuration: "/>
                                <p:selectOneMenu id="configuration" value="#{hl7CreatorBean.configuration}"
                                                 converter="omnifaces.SelectItemsConverter"
                                                 required="true" style="width:300px">
                                    <f:selectItem itemLabel="Select Configuration" itemValue=""
                                                  noSelectionOption="true"/>
                                    <f:selectItems value="#{hl7CreatorBean.configurations}" var="configuration"
                                                   itemValue="#{configuration}" itemLabel="#{configuration.name}"/>
                                    <f:ajax render="selected_item"/>
                                </p:selectOneMenu>
                            </h:panelGrid>
                        </p:panel>

                        <p:panel header="Configuration" id="selected_item" style="margin-bottom:10px;">
                            <h:panelGrid columns="2" cellpadding="5">
                                <h:outputText value="Name Receiver:"/>
                                <h:outputText value="#{hl7CreatorBean.configuration.name}"/>

                                <h:outputText value="Host Receiver:"/>
                                <h:outputText value="#{hl7CreatorBean.configuration.host}"/>

                                <h:outputText value="Port Receiver:"/>
                                <h:outputText value="#{hl7CreatorBean.configuration.port}"/>

                                <h:outputText value="App Receiver:"/>
                                <h:outputText value="#{hl7CreatorBean.configuration.application}"/>

                                <h:outputText value="Facility Receiver:"/>
                                <h:outputText value="#{hl7CreatorBean.configuration.facility}"/>


                                <h:outputText value="Port Supplier:"/>
                                <h:outputText value="#{hl7CreatorBean.getPortSupplier()}"/>


                            </h:panelGrid>
                        </p:panel>
                    </div>
                    <div class="col">

                        <p:panel header="Select a Message" style="margin-bottom:10px;">
                            <h:panelGrid columns="2" cellpadding="5">
                                <p:outputLabel for="messages" value="Message: "/>
                                <p:selectOneMenu id="messages" value="#{hl7CreatorBean.templateHl7v2}"
                                                 converter="omnifaces.SelectItemsConverter" required="true"
                                                 style="width:300px">
                                    <f:selectItem itemLabel="Select Message" itemValue=""
                                                  noSelectionOption="true"/>
                                    <f:selectItems value="#{hl7CreatorBean.getTemplatesHl7v2()}" var="templateHl7v2"
                                                   itemValue="#{templateHl7v2}" itemLabel="#{templateHl7v2.title}"/>
                                    <f:ajax render="selected_item_msg"/>
                                </p:selectOneMenu>
                            </h:panelGrid>
                        </p:panel>

                        <p:panel header="Message">
                            <h:panelGrid columns="2" cellpadding="5" id="selected_item_msg">
                                <h:outputText value="Message:"/>
                                <h:outputText value="#{hl7CreatorBean.templateHl7v2.description}"/>


                            </h:panelGrid>
                        </p:panel>
                    </div>
                </div>
                <p:commandButton value="Send" update="@(form)" action="#{hl7CreatorBean.send()}"
                                 style="margin-right: .5rem;"/>
                <p:commandButton value="Reset Config" styleClass="ui-button-secondary"
                                 action="#{hl7CreatorBean.resetCreatorServer()}"/>

            </h:form>


            <div id="historyMessage" class="card" style="margin-top: 10px">
                <h:form id="History">
                    <p:poll interval="2" update="messageHistory"/>

                    <p:dataTable id="messageHistory" var="message" value="#{hl7CreatorBean.getHistoryMessage()}">
                        <p:column headerText="Application Supplier">
                            <h:outputText value="#{message.applicationSupplier}"/>
                        </p:column>

                        <p:column headerText="Facility Supplier">
                            <h:outputText value="#{message.facilitySupplier}"/>
                        </p:column>

                        <p:column headerText="Application Receiver">
                            <h:outputText value="#{message.applicationReceiver}"/>
                        </p:column>

                        <p:column headerText="Facility Receiver">
                            <h:outputText value="#{message.facilityReceiver}"/>
                        </p:column>
                        <p:column headerText="Type Message">
                            <h:outputText value="#{message.typeMessage}"/>
                        </p:column>
                        <p:column>
                            <p:commandButton icon="pi pi-eye" update=":dialogs:manage-message-content"
                                             oncomplete="PF('manageMessageDialog').show()"
                                             styleClass="edit-button rounded-button ui-button-success"
                                             process="@this">
                                <f:setPropertyActionListener value="#{message}"
                                                             target="#{hl7CreatorBean.selectedMessageData}"/>
                                <p:resetInput target=":dialogs:manage-message-content"/>
                            </p:commandButton>

                        </p:column>
                    </p:dataTable>
                </h:form>
            </div>


            <h:form id="dialogs">
                <p:dialog header="Message Details" showEffect="fade" modal="true" widgetVar="manageMessageDialog"
                          width="80%" height="80%"  >
                    <p:outputPanel id="manage-message-content"  class="ui-fluid">
                        <h:outputText value="#{hl7CreatorBean.selectedMessageData.data}" style="white-space: pre-line"/>
                    </p:outputPanel>
                    <f:facet name="footer">
                        <p:commandButton value="Cancel" icon="pi pi-times" onclick="PF('manageMessageDialog').hide()"
                                         class="ui-button-secondary" type="button"/>
                    </f:facet>
                </p:dialog>


            </h:form>

        </div>

    </ui:define>
</ui:composition>


